import fxconv
import pathlib

# Normal template for a convert() function
def convert(input, output, params, target):
    if params["custom-type"] == "all-images":
        o = convert_all_images(input, params)
    else:
        return 1
    fxconv.elf(o, output, "_" + params["name"], **target)
    return 0

def convert_all_images(input, params):
    # o is going to be an array of [bopti_image_t *]
    o = fxconv.Structure()

    # Find all fxconv-metadata.txt in the folder where the input is located as
    # well as its subfolders
    for meta_file in pathlib.Path(input).parent.rglob("fxconv-metadata.txt"):
        # Load fxconv-metadata.txt
        metadata = fxconv.Metadata(meta_file)

        # Look for files in that folder that have type bopti-image (we assume
        # that all such files are declared in CMakeLists.txt!)
        for file in [e for e in meta_file.parent.iterdir() if e.is_file()]:
            params = metadata.rules_for(file)
            # For each such image, add a pointer to the converted structure.
            # The rules_for() resolves [name_regex] as [name] so we don't need
            # to worry about it.
            if params is not None and params.get("type") == "bopti-image":
                o += fxconv.ptr(params["name"])

    # Finish with a NULL pointer
    o += fxconv.u32(0)
    return o
